<template>
  <div class="line-chart">

    <div class="y-axis-label">
      <span>{{ chartLabels.yAxisLabel }}</span>
    </div>

    <div :class="`canvas__wrapper ${props.indicator}__wrapper q-py-sm`">
      <div :class="`containerBody_${props.indicator}`" style="height: 100% !important">
        <canvas :id="`canvas_${props.indicator}`"></canvas>
      </div>
    </div>

  </div>

  <div class="x-axis-label">
    <span>
      {{ chartLabels.xAxisLabel }}
    </span>
  </div>
</template>

<script setup>
import {
  computed,
  reactive,
  watchEffect,
  onMounted,
  onUpdated,
  toRaw,
} from 'vue';

import {
  Chart as ChartJS,
  registerables
} from 'chart.js';

import getChartLabels from 'src/composables/get_chart_labels';
import getNormalizedName from 'src/composables/get_normalized_name';

ChartJS.register(...registerables);

const props = defineProps({
  data:       { type: Object, required: true },
  indicator:  { type: String, required: true },
  parentSize: { required: true },
});

const localData = computed({
  get: () => toRaw(props.data).reduce((acc, item) => {
    if (item['porcentaje']) {
      acc[`${item['yearmonth']}`] = parseFloat(item['porcentaje']);
    } else if (item['register_number']) {
      acc[`${item['yearmonth']}`] = parseInt(item['register_number']);
    } else if (item['variabilidad']) {
      acc[`${item['yearmonth']}`] = parseFloat(item['variabilidad']);
    }
    return acc
  }, {}),
});

const sort = (obj) => Object.keys(obj)
  .sort()
  .reduce((acc, c) => { acc[c] = obj[c]; return acc }, {});

const makeScaleConfig = () => {
  const minChartDataValue = Math.min(...Object.values(localData.value));
  const maxChartDataValue = Math.max(...Object.values(localData.value));

  if (props.indicator === 'indicator_9') {
    return {
      min: 0,
      suggestedMax: maxChartDataValue,
      ticks: {
        callback: (value) => value + " %",
      },
    };

  } else if (props.indicator === 'indicator_10_11' || props.indicator === 'indicator_14') {
    return {
      min: minChartDataValue,
      suggestedMax: maxChartDataValue,
      ticks: {
        stepSize: 1,
      },
    };

  } else if (props.indicator === 'indicator_15') {
    return {
      suggestedMin: minChartDataValue,
      suggestedMax: maxChartDataValue,
      ticks: {
        callback: (value) => value.toLocaleString('es-EC', {style: 'currency', currency: 'USD'}),
      },
    };
  }
};

const makeTooltipConfig = () => {
  return {
    displayColors: false,
    callbacks: {
      label: (context => {
        let tooltipContent;
        switch (props.indicator) {
          case 'indicator_9':
            tooltipContent = `${context.parsed.y} %`;
            break;

          case 'indicator_10_11':
          case 'indicator_14':
            tooltipContent = `${context.parsed.y} registros`;
            break;

          case 'indicator_15':
            tooltipContent = context.parsed.y.toLocaleString('es-EC', {style: 'currency', currency: 'USD'});
            break;

          default:
            break;
        }
        return tooltipContent;
      }),
    },
  };
};

const makeChartConfig = () => {
  const data = sort(localData.value);
  const scaleConfig = makeScaleConfig();
  const tooltipConfig = makeTooltipConfig();

  return {
    type: 'line',
    data: {
      labels: Object.keys(data).map(elem => {
        const year = elem.split(".")[0];
        const month = parseInt(elem.split(".")[1]) - 1;
        const monthName = getNormalizedName(month, 'month_short_name');
        return [monthName, year];
      }),
      datasets: [
        {
          data: Object.values(data),
        }
      ]
    },
    options: {
      responsive: false,
      maintainAspectRatio: false,
      scales: {
        y: scaleConfig,
      },
      elements: {
        line: {
          backgroundColor: '#f26b30',
          borderColor: '#f26b30',
          borderWidth: 2,
        },
        point: {
          radius: 4,
          hoverRadius: 6,
          backgroundColor: '#f26b30',
        },
      },
      plugins: {
        legend: { display: false},
        tooltip: tooltipConfig,
      },
      layout: {
        padding: { left: 10, right: 20 },
      },
    },
  };
};

const chartLabels = getChartLabels(props.indicator);

const canvas_id = `canvas_${props.indicator}`;
const containerBodyClass = `containerBody_${props.indicator}`;

let myChart = {};

const createChart = function() {
  const ctx = document.getElementById(canvas_id);
  myChart = new ChartJS(ctx, data);
}

const resizeContainerBody = function() {
  const containerBody = document.querySelector(`.${containerBodyClass}`);
  if (containerBody) {
    if (data['data']['labels'].length > 0) {
      containerBody.style.width = `55vw`;
    }
    if (data['data']['labels'].length > 8) {
      let length = data['data']['labels'].length;
      let containerWidth = length * 85;
      containerBody.style.width = `${containerWidth}px`;
    }
  }
};

const resizeCanvasWrapper = function() {
  const canvasWrapper = document.querySelector(`.${props.indicator}__wrapper`);
  if(canvasWrapper) {
    canvasWrapper.style.width = `${props.parentSize.width * 0.95}px`;
  }
};

let data = reactive({});
watchEffect(() => {
  data = makeChartConfig();
});

onMounted(() => {
  resizeCanvasWrapper();
  createChart();
  resizeContainerBody();
});

onUpdated(() => {
  resizeCanvasWrapper();
  resizeContainerBody();
  if(document.getElementById(canvas_id)) {
    myChart.update();
    myChart.resize();
  }
});

</script>

<style lang="scss">
@use './line-chart-component-stylesheet.scss';
</style>